import useChrome from '../../useChrome';

var usePendoFeedback = function usePendoFeedback() {
  var _useChrome = useChrome(),
      usePendoFeedbackInternal = _useChrome.usePendoFeedback;
  /**
   * Return no-op in case the chrome changes are not avaiable in current env.
   */


  if (typeof usePendoFeedbackInternal !== 'function') {
    console.warn('The "usePendoFeedback" hook is not available in this enviroment. Default feedback form will be used. Wait for chrome updates.');
    return;
  }

  return usePendoFeedbackInternal.apply(void 0, arguments);
};

export default usePendoFeedback;